#!/usr/bin/env python

class B:
    def __init__(self, y):
        self.y = y
    def m(self, x):
        return x

class A:
    c1 = B
    m1 = B.m
    def __init__(self, b):
        self.c2 = B
        self.m2 = B.m
        self.c3 = b
        self.m3 = b.m

b = B(789)
a = A(b)
result_123 = A.m1(b, 123) # A.m1 is unbound
result_234 = a.m1(b, 234) # a.m1 is unbound
result_345 = a.m2(b, 345) # a.m2 is unbound
result_456 = a.m3(456)    # a.m3 is bound to b

b1 = A.c1(678)            # A.c1 is just a reference to B
result_678 = b1.y
b2 = a.c1(567)            # a.c1 is just a reference to B
result_567 = b2.y
b3 = a.c2(765)            # a.c2 is just a reference to B
result_765 = b3.y

# vim: tabstop=4 expandtab shiftwidth=4
